/*
 *	main.c
 *
 *	틅ǂ
 *
 *	* Sat Sep 29 15:33:19 JST 2007 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SOUND
const void* sound_table[SOUND_COUNT];
#endif /*USE_SOUND*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/*{{2007/09/28 P/EMU 48MHzΉΉ*/
	bP0_P0D_P07D = 1;
	/*}}2007/09/28 P/EMU 48MHzΉΉ*/

	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(!setjmp(jb_reset)) {
			demo_main();
		} else {
			break; /* I */
		}
		if(!setjmp(jb_reset)) {
			game_main();
		} else {
			no_demo_mask = 1;
		}
		if(game.score > hiscore) {
			hiscore = game.score;
		}
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef RESOURCE_FNAME
	/* pext@CYt\[X擾܂B */
	resource = resource_address(RESOURCE_FNAME);
#endif /*RESOURCE_FNAME*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_DBG
	/* DBGjbgݒ肵܂B */
	dbg_init();
#endif /*USE_DBG*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

#ifdef USE_2BIT_ADPCM
	/* 2-bit ADPCM DecoderN܂B */
	adpcm_init(ADPCM_CHANNELS);
#endif /*USE_2BIT_ADPCM*/

	/* TEh܂B */
#ifdef USE_SOUND
	{
#define SOUND_(name) { extern const unsigned char name[]; sound_table[SND_##name] = name; }
#define SOUND_RESOURCE_(name,fname) { sound_table[SND_##name] = fpk_address(resource, fname, NULL); }
#include "sound.h"
#undef SOUND_
#undef SOUND_RESOURCE_
	}
#endif /*USE_SOUND*/

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#define TEXTURE_RESOURCE_(name,fname) const void* const name = fpk_address(resource, fname, NULL);
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#define TEXTURE_RESOURCE_(name,fname) name,
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	no_demo_mask = 1;
	color_num = 5;
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_DBG
	/* DBGjbg̐ݒ܂B */
	dbg_free();
#endif /*USE_DBG*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	update
 ****************************************************************************/

/* * Mon Nov 06 17:37:17 JST 2006 Naoyuki Sawa
 * - schedule()AʍXV𕪗܂B
 *   t[҂ʍXVsꍇ́Å֐ĂяoĂB
 */
void
update()
{
#ifdef V_SCREEN
	/* vbuff(c)_def_vbuff()ϊ */
	unsigned char *dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
	unsigned char *src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
	int x, y;
	for(x = DISP_X - 1; x >= 0; x--) {
		for(y = 0; y < DISP_Y; y++) {
			*dst = *src;
			dst += 1;      /* ʂEɑ܂ */
			src += DISP_X; /* cʂɑ܂ */
		}
		                            /* ʂ͊Ɏ̍sֈړĂ܂ */
		src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
	}
#endif /*V_SCREEN*/

	/* ʓ] */
	pceLCDTrans();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

/* * Fri Dec 15 00:49:15 JST 2006 Naoyuki Sawa
 * - schedule()֐ɁATEh|[YΉR[hǉ܂B
 *   ł͏肭삵Ă悤łAX[v̕Aɖ肪NȂmFłB
 * - A|[YԂ̂܂܁AȂ킿ATEh|[YԂ̂܂܂ŃAvP[VIĂ܂ꍇɂA
 *   CLiPCupceAppExit()pceWaveStop(1)ĂяoĂATEhԂZbĝŁAvłB
 */

void
schedule()
{
#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		/*{{2006/12/15:TEh|[YΉ*/
		int sound_pause = 0/*x}*/;
		/*}}2006/12/15:TEh|[YΉ*/
		int x, y;
		for(;;) {
#endif /*USE_PAUSE*/
			update();		/* ʍXV */
			yield();		/* VXe */
			joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					sound_pause = fINT_EDMA.EHDM1;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 0;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 1;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	if(joy & TRG_SELECT) {
		longjmp(jb_reset, 1);
	}

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	
 ****************************************************************************/

#define FALL_CNT	8
static const char fall_ofs_dn[FALL_CNT][2] = { { 0,-8},{ 0,-7},{ 0,-6},{ 0,-5},{ 0,-4},{ 0,-3},{ 0,-2},{ 0,-1} };
static const char fall_ofs_rd[FALL_CNT][2] = { {-4,-8},{-3,-7},{-2,-6},{-1,-5},{-1,-4},{ 0,-3},{ 0,-2},{ 0,-1} };
static const char fall_ofs_ri[FALL_CNT][2] = { {-4,-1},{-4,-1},{-3,-1},{-3,-1},{-2,-1},{-2,-1},{-1, 0},{-1, 0} };
static const char fall_ofs_ld[FALL_CNT][2] = { { 4,-8},{ 3,-7},{ 2,-6},{ 1,-5},{ 1,-4},{ 0,-3},{ 0,-2},{ 0,-1} };
static const char fall_ofs_lf[FALL_CNT][2] = { { 4,-1},{ 4,-1},{ 3,-1},{ 3,-1},{ 2,-1},{ 2,-1},{ 1, 0},{ 1, 0} };

/*--------------------------------------------------------------------------*/

#define ROT_CNT1	2
#define ROT_CNT2	5
static const char rot_ofs_ri[2][3][ROT_CNT2][2] = {
	{{{ 0, 3},{ 0, 6},{ 0, 9},{ 1, 9},{ 3, 9}},{{-1, 0},{-3, 0},{-5, 0},{-5, 3},{-5, 6}},{{-1, 0},{-3, 0},{-5, 0},{-6, 0},{-8, 0}}},
	{{{ 1, 0},{ 3, 0},{ 5, 0},{ 6, 0},{ 8, 0}},{{ 1, 0},{ 3, 0},{ 5, 0},{ 5,-3},{ 5,-6}},{{ 0,-3},{ 0,-6},{ 0,-9},{-1,-9},{-3,-9}}},
};
static const char rot_ofs_lf[2][3][ROT_CNT2][2] = {
	{{{ 1, 0},{ 3, 0},{ 5, 0},{ 6, 0},{ 8, 0}},{{ 1, 0},{ 3, 0},{ 5, 0},{ 5, 3},{ 5, 6}},{{ 0, 3},{ 0, 6},{ 0, 9},{-1, 9},{-3, 9}}},
	{{{ 0,-3},{ 0,-6},{ 0,-9},{ 1,-9},{ 3,-9}},{{-1, 0},{-3, 0},{-5, 0},{-5,-3},{-5,-6}},{{-1, 0},{-3, 0},{-5, 0},{-6, 0},{-8, 0}}},
};

/*--------------------------------------------------------------------------*/

#define NEXT_POS_CNT	ARRAY_SIZE(next_pos_n)
#define X	69
#define Y	4
static const char next_pos_n[][2] = {
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X-1,Y+0},{X-2,Y+0}, {X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0}, {X-2,Y+0},{X-1,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X-1,Y+0},{X-2,Y+0}, {X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0}, {X-2,Y+0},{X-1,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X-1,Y+0},{X-2,Y+0}, {X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0}, {X-2,Y+0},{X-1,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X-1,Y+0},{X-2,Y+0}, {X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0},{X-3,Y+0}, {X-2,Y+0},{X-1,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
};
#undef X
#undef Y
#define X	74
#define Y	4
static const char next_pos_e[][2] = {
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X-0,Y+0},{X-1,Y+0}, {X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0}, {X-1,Y+0},{X-0,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X-0,Y+0},{X-1,Y+0}, {X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0}, {X-1,Y+0},{X-0,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X-0,Y+0},{X-1,Y+0}, {X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0}, {X-1,Y+0},{X-0,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X-0,Y+0},{X-1,Y+0}, {X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0},{X-1,Y+0}, {X-1,Y+0},{X-0,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
};
#undef X
#undef Y
#define X	78
#define Y	4
static const char next_pos_x[][2] = {
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y+0},{X+1,Y+0}, {X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0}, {X+1,Y+0},{X+0,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+1,Y+0}, {X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0}, {X+1,Y+0},{X+0,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+1,Y+0}, {X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0}, {X+1,Y+0},{X+0,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+1,Y+0}, {X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0},{X+1,Y+0}, {X+1,Y+0},{X+0,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
};
#undef X
#undef Y
#define X	82
#define Y	4
static const char next_pos_t[][2] = {
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y+1},{X+0,Y+2}, {X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3},{X+0,Y+3}, {X+0,Y+2},{X+0,Y+1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+0,Y-1},{X+0,Y-2}, {X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3}, {X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+1,Y+0},{X+2,Y+0}, {X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0}, {X+2,Y+0},{X+1,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+1,Y+0},{X+2,Y+0}, {X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0}, {X+2,Y+0},{X+1,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+1,Y+0},{X+2,Y+0}, {X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0}, {X+2,Y+0},{X+1,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	{X+1,Y+0},{X+2,Y+0}, {X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0},{X+3,Y+0}, {X+2,Y+0},{X+1,Y+0}, {X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},
	//
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},
	{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0},{X+0,Y+0}, {X+0,Y-1},{X+0,Y-2},{X+0,Y-3},{X+0,Y-3},{X+0,Y-3},{X+0,Y-2},{X+0,Y-1}, {X+0,Y+0},{X+0,Y+0},
};
#undef X
#undef Y

/*--------------------------------------------------------------------------*/

#define NEXT_X		69
#define NEXT_Y		23
#define NEXT_W		4
#define NEXT_H		8
#define NEXT_OFS_CNT	ARRAY_SIZE(next_ofs)
#define NEXT_OFS_MID	5
static const char next_ofs[] = { 0,8,16,24,32,40/*block_init()*/,32,24,16,8,0,3,5,3 };

/*--------------------------------------------------------------------------*/

#define RENSA_X		68
#define RENSA_Y		49
#define RENSA_NUM_X1	0	/* ?? */
#define RENSA_NUM_Y1	0
#define RENSA_NUM_X2	12	/* x?? */
#define RENSA_NUM_Y2	6
#define RENSA_ADD_Y	12

#define LEVEL_X		68
#define LEVEL_Y		95
#define BALLS_X		68
#define BALLS_Y		107
#define SCORE_X		68
#define SCORE_Y		119

/*--------------------------------------------------------------------------*/

#define ERASE_CNT1	12	/* _Ŏ() */
#define ERASE_CNT2	12	/* Ńp^[ */
#define BALLxE_CNT	3	/* gp^[ */
#define CHANGE_CNT	24	/* ωp^[ */

#define BALLxD_CNT	8	/* DFp^[ */

#define BLOCK_LAND_DELAY	SEC(0.5)
#define BLOCK_SPEED		block_speed()
#define JAMA_RATE		jama_rate()

static fixed
block_speed()
{
	static int level = -1;
	static fixed spd;
	//
	double d;
	int n;

	if(level != game.level) {
		level = game.level;

		d = 0.1;
		//
		n = level / 5;
		while(n--) {
			d *= 1.125;
		}
		//
		n = level % 5;
		while(n--) {
			d *= 1.125;
		}

		spd = fld(d);
	}

	return spd;
}

static int
jama_rate()
{
	static int level = -1;
	static int rate;
	//
	double d;
	int n;

	if(level != game.level) {
		level = game.level;

		n = level / 5;
		if(!n) {
			rate = 0;
		} else {
			d = 20.0;
			while(--n) {
				d *= 1.1;
			}
			rate = d + 0.5;
			if(rate > 50) {
				rate = 50;
			}
		}
	}

	return rate;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
demo_main()
{
	int stat = 0;
	int mask = 0;
	int sel = 0;
	int blink = 0;
	//
	int i;
	int x;
	int y;
	int c;
	int lf;
	int ri;

	if(no_demo_mask) {
		no_demo_mask = 0;
		stat = 1;
		mask = 128;
	} else {
		for(i = 0; i < SEC(0.25); i++) {
			schedule();
			mask_disp(0);
		}
	}

	for(;;) {
		schedule();
		surface_clear(&surface, 3);
		blink++;

		y = 16;
		for(x = 0; x < DISP_X; x += 8) {
			sprite_draw(x, y, SPR_LOGO_BG, DRW_NOMAL);
		}
		x = 4;
		sprite_draw(x, y, SPR_LOGO, DRW_NOMAL);
		x += 25;
		y += 47;
		sprite_draw(x, y, SPR_MODOKI, DRW_NOMAL);

		y = 1;
		x = 1;
		render_printf(&render, x, y, 0x82, 2, "1P %05d", game.score);
		render_printf(&render, x, y, 0x82, 0, "1P %5d", game.score);
		x = DISP_X - 32;
		render_printf(&render, x, y, 0x82, 2, "HI %05d", hiscore);
		render_printf(&render, x, y, 0x82, 0, "HI %5d", hiscore);

		x = 20;
		y = (128 - 6) - (8 * 5);
		c = 1;
		lf = ri = ' ';
		if(sel == 0) {
			c = 0;
			if(blink % SEC(0.5) < SEC(0.3)) {
				if(color_num > 3) lf = '<';
				if(color_num < 5) ri = '>';
			}
		}
		render_printf(&render, x, y, 0x82, c, "%c COLOR %2d %c", lf, color_num, ri);
		y = (128 - 6) - (8 * 4);
		c = 1;
		lf = ri = ' ';
		if(sel == 1) {
			c = 0;
			if(blink % SEC(0.5) < SEC(0.3)) {
				if(level_sel >  0) lf = '<';
				if(level_sel < 99) ri = '>';
			}
		}
		render_printf(&render, x, y, 0x82, c, "%c LEVEL %2d %c", lf, level_sel, ri);
		y = (128 - 6) - (8 * 2);
		render_string(&render, x, y, " START [A]  ", 0x82, 1);
		y = (128 - 6) - (8 * 1);
		render_string(&render, x, y, " EXIT [SEL] ", 0x82, 1);

		mask_disp(mask);

		if(stat == 0) {
			if(mask < 128) {
				mask += 16;
			} else {
				stat = 1;
			}
		}

		if(stat == 1) {
			if(joy & (TRG_UP | TRG_DN)) {
				sel ^= 1;
				blink = 0;
			}
			if(sel == 0) {
				if((joy & TRG_LF) && (color_num > 3)) {
					color_num--;
					blink = 0;
				}
				if((joy & TRG_RI) && (color_num < 5)) {
					color_num++;
					blink = 0;
				}
			}
			if(sel == 1) {
				if((joy & TRG_LF) && (level_sel >  0)) {
					level_sel--;
					blink = 0;
				}
				if((joy & TRG_RI) && (level_sel < 99)) {
					level_sel++;
					blink = 0;
				}
			}
			if(joy & TRG_A) {
				stat = 2;
			}
		}

		if(stat == 2) {
			if(mask > 0) {
				mask -= 16;
			} else {
				break;
			}
		}
	}

	for(i = 0; i < SEC(0.25); i++) {
		schedule();
		mask_disp(0);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
game_main()
{
	int retval;
	int i;

	game_init();
	block_init(); /* ŏNEXT */

	/* START\B */
	game.stat = GAME_STAT_START;
	for(i = 0; i <= 128; i += 16) {
		schedule();
		field_disp();
		mask_disp(i);
	}
	for(i = 0; i < SEC(0.5); i++) {
		schedule();
		field_disp();
	}
	game.moji_cnt = 1; /* STARTړJn */

	for(;;) {
		/* NEXTooB */
		game.stat = GAME_STAT_NEXT;
		do {
			schedule();
			field_disp();
		} while(++game.next_cnt < NEXT_OFS_MID);
		retval = block_init();
		do {
			schedule();
			field_disp();
		} while(++game.next_cnt < NEXT_OFS_CNT);
		game.next_cnt = 0;
		if(!retval) {
			break; /* Q[I[o[ */
		}

		/* ubNړB */
		game.stat = GAME_STAT_MOVE;
		for(;;) {
			schedule();
			field_disp();
			block_disp();
			if(!block_action()) {
				break;
			}
		}
		block_realize();

		for(;;) {
			/* RB */
			game.stat = GAME_STAT_FALL;
			for(;;) {
				if(!fall_init()) {
					break;
				}
				do {
					schedule();
					field_disp();
				} while(fall_action());
			}

			/* ŁB */
			game.stat = GAME_STAT_ERASE;
			if(!erase_init()) {
				break;
			}
			do {
				schedule();
				field_disp();
			} while(erase_action());

			game.combo++; /* ݂̘A */
			game.erase++; /* xAbvp */
		}

		/* AvB */
		rensa_add();
		game.combo = 0;

		/* xAbvB */
		if(game.erase >= 2) {
			/* ǂȂɑAĂx1xオȂdl? */
			if(game.erase > 2) {
				game.erase = 1;
			} else {
				game.erase = 0;
			}
			if(game.level < 99999) {
				game.level++;
			}
			game.level_blink = 1;
		}
	}

	/* |[ʊOoB */
	gameover_init();
	do {
		schedule();
		field_disp();
	} while(gameover_action());

	/* GAMEOVER\B */
	game.stat = GAME_STAT_GAMEOVER;
	game.moji_cnt = SEC(0.5);
	for(i = 0; i < SEC(10.0); i++) {
		schedule();
		field_disp();
		if((i >= SEC(1.0)) && (joy & TRG_AB)) {
			break;
		}
	}
	for(i = 128; i >= 0; i -= 16) {
		schedule();
		field_disp();
		mask_disp(i);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
game_init()
{
	memset(&game, 0, sizeof game);

	game.level = level_sel;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
block_init()
{
	memcpy(game.block, game.next,    sizeof game.next);
	memset(            game.next, 0, sizeof game.next);

	game.next[0][1] = 1 + RND32_RANGE(seed, 0, color_num);
	game.next[1][0] = 1 + RND32_RANGE(seed, 0, color_num);
	game.next[1][2] = 1 + RND32_RANGE(seed, 0, color_num);
	if(RND32_RANGE(seed, 0, 100) < JAMA_RATE) game.next[0][1] |= CELL_TYPE_JAMA;
	if(RND32_RANGE(seed, 0, 100) < JAMA_RATE) game.next[1][0] |= CELL_TYPE_JAMA;
	if(RND32_RANGE(seed, 0, 100) < JAMA_RATE) game.next[1][2] |= CELL_TYPE_JAMA;

	game.block_stat = BLOCK_STAT_FALL;
	game.block_cnt = 0;
	game.block_rot = 0;
	game.block_col = 4;
	game.block_row = 1;
	game.block_ofs = fld(0.5);
	if(move_test(game.block_col, game.block_row)) {
		return 1;
	}
	game.block_row = 0;
	game.block_ofs = fld(0.0);
	if(move_test(game.block_col, game.block_row)) {
		return 1;
	}
	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
block_disp()
{
	int i;
	int x;
	int y;
	int col;
	int row;
	int type;
	int spr;

	for(i = 0; i < 2; i++) {
		for(row = 0; row < 2; row++) {
			for(col = 0; col < 3; col++) {
				type = game.block[row][col];
				if(!type) {
					continue;
				}
				x = FIELD_X + CELL_W * (game.block_col + col);
				y = FIELD_Y + CELL_H * (game.block_row + row) - ficeil(fimul(game.block_ofs, CELL_H));
				if(game.block_rot > 0) {
					x += rot_ofs_lf[row][col][ game.block_rot - 1][0];
					y += rot_ofs_lf[row][col][ game.block_rot - 1][1];
				}
				if(game.block_rot < 0) {
					x += rot_ofs_ri[row][col][-game.block_rot - 1][0];
					y += rot_ofs_ri[row][col][-game.block_rot - 1][1];
				}
				if(i) {
					if(type & CELL_TYPE_JAMA) {
						spr = SPR_JAMA1 + ((type & ~CELL_TYPE_JAMA) - 1);
					} else {
						spr = SPR_BALL1 + (type - 1);
					}
				} else {
					spr = SPR_WAKU0 + abs(now / 2 % 6 - 3); /* [3,2,1,0,1,2] */
				}
				sprite_draw(x, y, spr, DRW_NOMAL);
			}
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

int
block_action()
{
	fixed spd;

	if(game.block_rot < 0) game.block_rot++;
	if(game.block_rot > 0) game.block_rot--;

	switch(game.block_stat) {
	case BLOCK_STAT_FALL:
		spd = BLOCK_SPEED;
		if(joy & PAD_DN/**/) {
			if(fcom(spd, <, fld(1.0))) {
				spd = fld(1.0);
			}
			add_score(1);
		}
		fsub_(game.block_ofs, spd);
		while(fcom(game.block_ofs, <=, fld(0.0))) {
			if(!move_test(game.block_col, game.block_row + 1)) { /* ڒn */
				game.block_ofs = fld(0.0);
				game.block_stat = BLOCK_STAT_LAND;
				game.block_cnt = BLOCK_LAND_DELAY;
				break;
			}
			game.block_row++;
			fadd_(game.block_ofs, fld(1.0));
		}
		break;
	case BLOCK_STAT_LAND:
		if(move_test(game.block_col, game.block_row + 1)) { /* ĊJ */
			game.block_stat = BLOCK_STAT_FALL;
		} else {
			game.block_cnt--;
			if((game.block_cnt <= 0) || (joy & TRG_DN/*ڒ*/)) {
				return 0; /* ڒ */
			}
		}
		break;
	default:
		DIE();
	}

	if(joy & TRG_LF) {
		if(move_test(game.block_col - 1, game.block_row)) {
			game.block_col--;
		}
	}
	if(joy & TRG_RI) {
		if(move_test(game.block_col + 1, game.block_row)) {
			game.block_col++;
		}
	}
	if(joy & TRG_A) {
		block_rot(1);
		if(move_test(game.block_col, game.block_row)) {
			game.block_rot = -ROT_CNT1;
			add_score(1);
		} else {
			block_rot(1);
			game.block_rot = -ROT_CNT2;
			add_score(2);
		}
	}
	if(joy & TRG_B) {
		block_rot(-1);
		if(move_test(game.block_col, game.block_row)) {
			game.block_rot = ROT_CNT1;
			add_score(1);
		} else {
			block_rot(-1);
			game.block_rot = ROT_CNT2;
			add_score(2);
		}
	}

	return 1; /* p */
}

/****************************************************************************
 *	
 ****************************************************************************/

void
block_realize()
{
	int col;
	int row;
	int type;
	CELL* cell;

	for(row = 0; row < 2; row++) {
		for(col = 0; col < 3; col++) {
			type = game.block[row][col];
			if(!type) {
				continue;
			}
			cell = &game.field[game.block_row + row][game.block_col + col];
			memset(cell, 0, sizeof(CELL));
			cell->type = type;
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
field_disp()
{
	static unsigned char* bgbuff;
	//
	int x;
	int y;
	int col;
	int row;
	int spr;
	CELL* cell;

	/* i`B */
	if(!bgbuff) {
		bgbuff = malloc(DISP_X * DISP_Y);
		if(!bgbuff) {
			DIE();
		}
		sprite_draw(0, 0, SPR_TTT, DRW_NOMAL);
		render_rectangle_shadow(&render, 68, 7, 20, 34, 1, 3); /* NEXT̈Â */
		memcpy(bgbuff, vbuff, DISP_X * DISP_Y);
	}
	memcpy(vbuff, bgbuff, DISP_X * DISP_Y);

	/* Z`B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			x = FIELD_X + CELL_W * col;
			y = FIELD_Y + CELL_H * row;
			if(cell->type & CELL_TYPE_JAMA) {
				spr = SPR_JAMA1 + ((cell->type & ~CELL_TYPE_JAMA) - 1);
			} else {
				spr = SPR_BALL1 + ( cell->type                    - 1);
			}
			switch(cell->stat) {
			case CELL_STAT_FALL_DN:
				if(cell->cnt < FALL_CNT) {
					x += fall_ofs_dn[cell->cnt][0];
					y += fall_ofs_dn[cell->cnt][1];
				}
				break;
			case CELL_STAT_FALL_RD:
				if(cell->cnt < FALL_CNT) {
					x += fall_ofs_rd[cell->cnt][0];
					y += fall_ofs_rd[cell->cnt][1];
				}
				break;
			case CELL_STAT_FALL_RI:
				if(cell->cnt < FALL_CNT) {
					x += fall_ofs_ri[cell->cnt][0];
					y += fall_ofs_ri[cell->cnt][1];
				}
				break;
			case CELL_STAT_FALL_LD:
				if(cell->cnt < FALL_CNT) {
					x += fall_ofs_ld[cell->cnt][0];
					y += fall_ofs_ld[cell->cnt][1];
				}
				break;
			case CELL_STAT_FALL_LF:
				if(cell->cnt < FALL_CNT) {
					x += fall_ofs_lf[cell->cnt][0];
					y += fall_ofs_lf[cell->cnt][1];
				}
				break;
			case CELL_STAT_ERASE:
				if(cell->cnt >= 0) {
					if(cell->cnt < ERASE_CNT1) {
						if(!(cell->cnt & 2)) {
							spr = SPR_BALL1F + (cell->type - 1);
						}
					} else {
						spr = -1;
					}
				}
				break;
			case CELL_STAT_CHANGE:
				spr = SPR_CHANGE1_00 + ((cell->type & ~CELL_TYPE_JAMA) - 1) * CHANGE_CNT + cell->cnt;
				break;
			case CELL_STAT_DARK:
				if(cell->cnt >= 0) {
					if(cell->type & CELL_TYPE_JAMA) {
						spr = SPR_JAMA1D_0 + ((cell->type & ~CELL_TYPE_JAMA) - 1) * BALLxD_CNT + cell->cnt;
					} else {
						spr = SPR_BALL1D_0 + ( cell->type                    - 1) * BALLxD_CNT + cell->cnt;
					}
				}
				break;
			case CELL_STAT_OVER:
				if(cell->type & CELL_TYPE_JAMA) {
					spr = SPR_JAMA1D_0 + ((cell->type & ~CELL_TYPE_JAMA) - 1) * BALLxD_CNT + (BALLxD_CNT - 1);
				} else {
					spr = SPR_BALL1D_0 + ( cell->type                    - 1) * BALLxD_CNT + (BALLxD_CNT - 1);
				}
				if(cell->cnt > 0) {
					y += cell->cnt * cell->cnt / 8/**/;
					if(y >= DISP_Y) {
						memset(cell, 0, sizeof(CELL));
						spr = -1;
					}
				}
				break;
			}
			if(spr >= 0) {
				sprite_draw(x, y, spr, DRW_NOMAL);
			}
		}
	}

	/* wi`B(ʏZOł) */
	sprite_draw(0, 0, SPR_BG, DRW_NOMAL);

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			x = FIELD_X + CELL_W * col;
			y = FIELD_Y + CELL_H * row;
			spr = -1;
			switch(cell->stat) {
			case CELL_STAT_ERASE:
				if(cell->cnt == ERASE_CNT1) {
					hahen_gen(x + 5, y + 4);
				}
				if(cell->cnt >= ERASE_CNT1 &&
				   cell->cnt < (ERASE_CNT1 + BALLxE_CNT)) {
					spr = SPR_BALL1E_0 + (cell->type - 1) * BALLxE_CNT + (cell->cnt - ERASE_CNT1);
				}
				break;
			}
			if(spr >= 0) {
				sprite_draw(x, y, spr, DRW_NOMAL);
			}
		}
	}

	hahen_disp();

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			x = FIELD_X + CELL_W * col;
			y = FIELD_Y + CELL_H * row;
			spr = -1;
			switch(cell->stat) {
			case CELL_STAT_ERASE:
				if(cell->cnt >= ERASE_CNT1 &&
				   cell->cnt < (ERASE_CNT1 + ERASE_CNT2)) {
					spr = SPR_ERASE_00 + (cell->cnt - ERASE_CNT1);
				}
				break;
			}
			if(spr >= 0) {
				sprite_draw(x, y, spr, DRW_NOMAL);
			}
		}
	}

	next_disp();
	info_disp();
	if(game.stat < GAME_STAT_GAMEOVER) {
		start_disp();
	} else {
		gameover_disp();
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
block_rot(int dir)
{
	int tmp;

	switch(dir) {
	case  1: /* E] */
		tmp = game.block[0][0];
		      game.block[0][0] = game.block[1][0];
		                         game.block[1][0] = game.block[1][1];
		                                            game.block[1][1] = game.block[1][2];
		                                                               game.block[1][2] = game.block[0][2];
		                                                                                  game.block[0][2] = game.block[0][1];
		                                                                                                     game.block[0][1] = tmp;
		break;
	case -1: /* ] */
		tmp = game.block[0][0];
		      game.block[0][0] = game.block[0][1];
		                         game.block[0][1] = game.block[0][2];
		                                            game.block[0][2] = game.block[1][2];
		                                                               game.block[1][2] = game.block[1][1];
		                                                                                  game.block[1][1] = game.block[1][0];
		                                                                                                     game.block[1][0] = tmp;
		break;
	default:
		DIE();
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

int
move_test(int block_col, int block_row)
{
	int col;
	int row;
	int type;

	for(row = 0; row < 2; row++) {
		for(col = 0; col < 3; col++) {
			type = game.block[row][col];
			if(!type) {
				continue;
			}
			if(!blank_test(block_col + col - 1, block_row + row) ||
			   !blank_test(block_col + col    , block_row + row) ||
			   !blank_test(block_col + col + 1, block_row + row)) {
				return 0;
			}
		}
	}

	return 1;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
blank_test(int col, int row)
{
	if((row < 0) || (row > FIELD_ROWS - 1)) {
		if(row == FIELD_ROWS) {
			if((col >= 0) && (col <= FIELD_COLS - 1)) {
				if(!(col & 1)) {
					return 1;
				}
			}
		}
		return 0;
	}

	if((col < 0) || (col > FIELD_COLS - 1)) {
		if(game.stat == GAME_STAT_FALL) {
			if(row & 1) {
				if(col == -1 || col == FIELD_COLS) {
					return 1;
				}
			}
		} else {
			if(col == -1 || col == FIELD_COLS) {
				return 1;
			}
		}
		return 0;
	}

	return !game.field[row][col].type;
}

/****************************************************************************
 *	
 ****************************************************************************/

static int
fall_init_dn(int col, int row)
{
	CELL* cell1;
	CELL* cell2;
	if(blank_test(col - 1, row + 1) &&
	   blank_test(col    , row + 1) &&
	   blank_test(col + 1, row + 1)) {
		cell1 = &game.field[row    ][col];
		cell2 = &game.field[row + 1][col];
		memcpy(cell2, cell1, sizeof(CELL));
		memset(cell1,     0, sizeof(CELL));
		cell2->stat = CELL_STAT_FALL_DN;
		cell2->cnt = 0;
		return 1;
	}
	return 0;
}

static int
fall_init_rd(int col, int row)
{
	CELL* cell1;
	CELL* cell2;
	if(blank_test(col    , row + 1) &&
	   blank_test(col + 1, row + 1) &&
	   blank_test(col + 2, row + 1)) {
		cell1 = &game.field[row    ][col    ];
		cell2 = &game.field[row + 1][col + 1];
		memcpy(cell2, cell1, sizeof(CELL));
		memset(cell1,     0, sizeof(CELL));
		cell2->stat = CELL_STAT_FALL_RD;
		cell2->cnt = 0;
		return 1;
	}
	return 0;
}

static int
fall_init_ri(int col, int row)
{
	CELL* cell1;
	CELL* cell2;
	if(blank_test(col + 2, row)) {
		cell1 = &game.field[row][col    ];
		cell2 = &game.field[row][col + 1];
		memcpy(cell2, cell1, sizeof(CELL));
		memset(cell1,     0, sizeof(CELL));
		cell2->stat = CELL_STAT_FALL_RI;
		cell2->cnt = 0;
		return 1;
	}
	return 0;
}

static int
fall_init_ld(int col, int row)
{
	CELL* cell1;
	CELL* cell2;
	if(blank_test(col    , row + 1) &&
	   blank_test(col - 1, row + 1) &&
	   blank_test(col - 2, row + 1)) {
		cell1 = &game.field[row    ][col    ];
		cell2 = &game.field[row + 1][col - 1];
		memcpy(cell2, cell1, sizeof(CELL));
		memset(cell1,     0, sizeof(CELL));
		cell2->stat = CELL_STAT_FALL_LD;
		cell2->cnt = 0;
		return 1;
	}
	return 0;
}

static int
fall_init_lf(int col, int row)
{
	CELL* cell1;
	CELL* cell2;
	if(blank_test(col - 2, row)) {
		cell1 = &game.field[row][col    ];
		cell2 = &game.field[row][col - 1];
		memcpy(cell2, cell1, sizeof(CELL));
		memset(cell1,     0, sizeof(CELL));
		cell2->stat = CELL_STAT_FALL_LF;
		cell2->cnt = 0;
		return 1;
	}
	return 0;
}

/* u΂߉ړ̏ƂȂ^ړ́A΂߉ړƓDxƂvłB
 * <>
 *		   
 *		  BA
 *		   @
 *		   
 *		  
 *
 *	Ȃ΁AȂ܂B
 *
 *		   @
 *		BA
 *
 *	΁AȂ܂B
 *
 *		   A
 *		B@
 *
 *	A{̋ɋ߂łB
 */
#define NANAME_YOKO_PRIOR

int
fall_init()
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell;
REDO:
	/* ^ */
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat) {
				continue;
			}
			if(fall_init_dn(col, row)) {
				active = 1;
				goto REDO;
			}
		}
	}
	/* ΂߉ */
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat) {
				continue;
			}
			/* E */
			if(!blank_test(col - 1, row - 1) &&
			    blank_test(col + 1, row - 1)) {
				if(fall_init_rd(col, row)) {
					active = 1;
					goto REDO;
				}
			}
			/*  */
			if(!blank_test(col + 1, row - 1) &&
			    blank_test(col - 1, row - 1)) {
				if(fall_init_ld(col, row)) {
					active = 1;
					goto REDO;
				}
			}
			/* E */
			if(fall_init_rd(col, row)) {
				active = 1;
				goto REDO;
			}
			/*  */
			if(fall_init_ld(col, row)) {
				active = 1;
				goto REDO;
			}
#ifdef NANAME_YOKO_PRIOR /* L̏ꍇ */
			if(!blank_test(col - 1, row - 1) &&
			    blank_test(col + 1, row - 1)) {
				continue;
			}
			if(!blank_test(col + 1, row - 1) &&
			    blank_test(col - 1, row - 1)) {
				continue;
			}
			if(!blank_test(col, row + 1)) {
				/* E */
				if(blank_test(col + 2, row + 1) &&
				   blank_test(col + 3, row + 1)) {
					if(fall_init_ri(col, row)) {
						active = 1;
						goto REDO;
					}
				}
				/*  */
				if(blank_test(col - 2, row + 1) &&
				   blank_test(col - 3, row + 1)) {
					if(fall_init_lf(col, row)) {
						active = 1;
						goto REDO;
					}
				}
			}
#endif /*NANAME_YOKO_PRIOR*/
		}
	}
	/* ^ */
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat) {
				continue;
			}
			/* E */
			if(!blank_test(col - 1, row - 1) &&
			    blank_test(col + 1, row - 1)) {
				if(!blank_test(col, row + 1)) {
					if(fall_init_ri(col, row)) {
						active = 1;
						goto REDO;
					}
				}
			}
			/*  */
			if(!blank_test(col + 1, row - 1) &&
			    blank_test(col - 1, row - 1)) {
				if(!blank_test(col, row + 1)) {
					if(fall_init_lf(col, row)) {
						active = 1;
						goto REDO;
					}
				}
			}
			if(!blank_test(col, row + 1)) {
#ifndef NANAME_YOKO_PRIOR /* ̏ꍇ */
				/* E */
				if(blank_test(col + 2, row + 1) &&
				   blank_test(col + 3, row + 1)) {
					if(fall_init_ri(col, row)) {
						active = 1;
						goto REDO;
					}
				}
				/*  */
				if(blank_test(col - 2, row + 1) &&
				   blank_test(col - 3, row + 1)) {
					if(fall_init_lf(col, row)) {
						active = 1;
						goto REDO;
					}
				}
#endif /*NANAME_YOKO_PRIOR*/
				/* E */
				if(fall_init_ri(col, row)) {
					active = 1;
					goto REDO;
				}
				/*  */
				if(fall_init_lf(col, row)) {
					active = 1;
					goto REDO;
				}
			}
		}
	}

	return active;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
fall_action()
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			switch(cell->stat) {
			case CELL_STAT_FALL_DN:
			case CELL_STAT_FALL_RD:
			case CELL_STAT_FALL_RI:
			case CELL_STAT_FALL_LD:
			case CELL_STAT_FALL_LF:
				cell->cnt += 2/**/;
				if(cell->cnt >= FALL_CNT) {
					cell->stat = 0;
					cell->cnt = 0;
				}
				active = 1;
				break;
			}
		}
	}

	return active;
}

/****************************************************************************
 *	
 ****************************************************************************/

static int
erase_init_sub1(int col, int row, int type)
{
	CELL* cell;

	if(col < 0 || col > FIELD_COLS - 1 ||
	   row < 0 || row > FIELD_ROWS - 1) {
		return 0;
	}

	cell = &game.field[row][col];
	if(cell->type != type) {
		return 0;
	}
	if(cell->stat) {
		return 0;
	}

	cell->type |= CELL_TYPE_MARK;

	return 1 +
		erase_init_sub1(col + 1, row + 1, type) +
		erase_init_sub1(col - 1, row + 1, type) +
		erase_init_sub1(col + 2, row    , type) +
		erase_init_sub1(col - 2, row    , type) +
		erase_init_sub1(col + 1, row - 1, type) +
		erase_init_sub1(col - 1, row - 1, type);
}

static void
erase_init_sub2(int col, int row, int delay)
{
	CELL* cell;

	if(col < 0 || col > FIELD_COLS - 1 ||
	   row < 0 || row > FIELD_ROWS - 1) {
		return;
	}

	cell = &game.field[row][col];
	if(!(cell->type & CELL_TYPE_MARK)) {
		if(cell->type & CELL_TYPE_JAMA) {
			cell->stat = CELL_STAT_CHANGE;
			cell->cnt = 0;
		}
		return;
	}

	cell->type &= ~CELL_TYPE_MARK;
	cell->stat = CELL_STAT_ERASE;
	cell->cnt = -delay;
	delay++;

	erase_init_sub2(col + 1, row + 1, delay);
	erase_init_sub2(col - 1, row + 1, delay);
	erase_init_sub2(col + 2, row    , delay);
	erase_init_sub2(col - 2, row    , delay);
	erase_init_sub2(col + 1, row - 1, delay);
	erase_init_sub2(col - 1, row - 1, delay);
}

static void
erase_init_sub3(int col, int row)
{
	CELL* cell;

	if(col < 0 || col > FIELD_COLS - 1 ||
	   row < 0 || row > FIELD_ROWS - 1) {
		return;
	}

	cell = &game.field[row][col];
	if(!(cell->type & CELL_TYPE_MARK)) {
		return;
	}

	cell->type &= ~CELL_TYPE_MARK;

	erase_init_sub3(col + 1, row + 1);
	erase_init_sub3(col - 1, row + 1);
	erase_init_sub3(col + 2, row    );
	erase_init_sub3(col - 2, row    );
	erase_init_sub3(col + 1, row - 1);
	erase_init_sub3(col - 1, row - 1);
}

int
erase_init()
{
	int active = 0;
	//
	int col;
	int row;
	int delay;
	int chain;
	CELL* cell;

	delay = 0;
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat) {
				continue;
			}
			if(cell->type & CELL_TYPE_JAMA) {
				continue;
			}
			chain = erase_init_sub1(col, row, cell->type);
			if(chain >= 4) {
				erase_init_sub2(col, row, delay);
				delay++;
				game.balls += chain;
				if(game.balls > 99999) {
					game.balls = 99999;
				}
				add_score((game.combo + 1) * 10 * (chain - 3));
				active = 1;
			} else {
				erase_init_sub3(col, row);
			}
		}
	}

	return active;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
erase_action()
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			switch(cell->stat) {
			case CELL_STAT_ERASE:
				cell->cnt++;
				if(cell->cnt >= (ERASE_CNT1 + ERASE_CNT2)) {
					memset(cell, 0, sizeof(CELL));
				}
				active = 1;
				break;
			case CELL_STAT_CHANGE:
				cell->cnt++;
				if(cell->cnt >= CHANGE_CNT) {
					cell->type &= ~CELL_TYPE_JAMA;
					cell->stat = 0;
					cell->cnt = 0;
				}
				active = 1;
				break;
			}
		}
	}

	return active;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
hahen_gen(int x, int y)
{
	int i;
	int n;
	HAHEN* hahen;
	fixed v;
	fixed r;

	n = 8; /*  */
	i = 0;

	do {
		hahen = &game.hahen[i];
		if(fcom(hahen->size, >=, fld(0.1))) {
			continue;
		}

		v = FRND_RANGE(seed, fld(0.5), fld(2.0));
		r = FRND_RANGE(seed, fld(0.0), PI2);

		hahen->size = FRND_RANGE(seed, fld(2.0), fld(5.0));
		hahen->x = fld(x);
		hahen->y = fld(y);
		hahen->vx = fmul(fcos(r), v);
		hahen->vy = fmul(fsin(r), v);

		if(!--n) {
			break;
		}
	} while(++i < HAHEN_MAX);
}

/****************************************************************************
 *	
 ****************************************************************************/

void
hahen_disp()
{
	int i;
	HAHEN* hahen;
	int size;
	int x;
	int y;
	int c;

	for(i = 0; i < HAHEN_MAX; i++) {
		hahen = &game.hahen[i];
		if(fcom(hahen->size, <, fld(0.1))) {
			continue;
		}

		size = fist(fadd(hahen->size, fld(0.5)));
		x = fist(fadd(hahen->x, fld(0.5)));
		y = fist(fadd(hahen->y, fld(0.5)));
		       if(fcom(hahen->size, <, fld(0.4))) {
			c = 0;
		} else if(fcom(hahen->size, <, fld(0.7))) {
			c = 1;
		} else if(fcom(hahen->size, <, fld(1.0))) {
			c = 2;
		} else {
			c = 3;
		}
		render_rectangle_fill(&render,
			x - size / 2,
			y - size / 2,
			size,
			size,
			c);

		fmul_(hahen->size, fld(0.9));
		fadd_(hahen->x, hahen->vx);
		fadd_(hahen->y, hahen->vy);
		fmul_(hahen->vx, fld(0.75));
		fmul_(hahen->vy, fld(0.75));
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
next_disp()
{
	int i;
	int x;
	int y;
	int col;
	int row;
	int type;
	int spr;

	i = (now / 2) % NEXT_POS_CNT;
	x = next_pos_n[i][0];
	y = next_pos_n[i][1];
	spr = SPR_NEXT_N;
	sprite_draw(x, y, spr, DRW_NOMAL);
	x = next_pos_e[i][0];
	y = next_pos_e[i][1];
	spr = SPR_NEXT_E;
	sprite_draw(x, y, spr, DRW_NOMAL);
	x = next_pos_x[i][0];
	y = next_pos_x[i][1];
	spr = SPR_NEXT_X;
	sprite_draw(x, y, spr, DRW_NOMAL);
	x = next_pos_t[i][0];
	y = next_pos_t[i][1];
	spr = SPR_NEXT_T;
	sprite_draw(x, y, spr, DRW_NOMAL);

	for(row = 0; row < 2; row++) {
		for(col = 0; col < 3; col++) {
			type = game.next[row][col];
			if(!type) {
				continue;
			}
			x = NEXT_X + NEXT_W * col;
			y = NEXT_Y + NEXT_H * row - next_ofs[game.next_cnt];
			if(type & CELL_TYPE_JAMA) {
				spr = SPR_JAMA1N + ((type & ~CELL_TYPE_JAMA) - 1);
			} else {
				spr = SPR_BALL1N + (type - 1);
			}
			sprite_draw(x, y, spr, DRW_NOMAL);
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

static const unsigned char blink_tbl[] = {
	3,3,2,2,1,1,0,0,1,1,2,2,
	3,3,2,2,1,1,0,0,1,1,2,2,
	3,3,2,2,1,1,0,0,1,1,2,2,
};

void
info_disp()
{
	int i;
	int x;
	int y;
	int c;

	x = RENSA_X;
	y = RENSA_Y;
	for(i = RENSA_MAX - 1; i >= 0; i--) {
		if(!game.rensa[i].combo) {
			continue;
		}
		c = blink_tbl[game.rensa[i].blink];
		if(game.rensa[i].blink) {
			game.rensa[i].blink++;
			if(game.rensa[i].blink >= ARRAY_SIZE(blink_tbl)) {
				game.rensa[i].blink = 0;
			}
		}
		sprite_draw(x, y, SPR_RENSA, DRW_NOMAL);
		render_printf_framed(&render, x + RENSA_NUM_X1, y + RENSA_NUM_Y1, 0x82, 3, "%2d", game.rensa[i].combo);
		render_printf_framed(&render, x + RENSA_NUM_X2, y + RENSA_NUM_Y2, 0x82, c, "%2d", game.rensa[i].cnt);
		y += RENSA_ADD_Y;
	}

	c = blink_tbl[game.level_blink];
	if(game.level_blink) {
		game.level_blink++;
		if(game.level_blink >= ARRAY_SIZE(blink_tbl)) {
			game.level_blink = 0;
		}
	}
	render_string_framed(&render, LEVEL_X, LEVEL_Y - 6, "LEVEL", 0x82, 3);
	render_string_framed(&render, BALLS_X, BALLS_Y - 6, "BALLS", 0x82, 3);
	render_string_framed(&render, SCORE_X, SCORE_Y - 6, "SCORE", 0x82, 3);
	render_printf_framed(&render, LEVEL_X, LEVEL_Y, 0x82, c, "%5d", game.level);
	render_printf_framed(&render, BALLS_X, BALLS_Y, 0x82, 3, "%5d", game.balls);
	render_printf_framed(&render, SCORE_X, SCORE_Y, 0x82, 3, "%5d", game.score);

	/*{{DEBUG*/
	{
		static int on;
		if((joy & PAD_A) && (joy & PAD_B) && (joy & TRG_UP)) {
			on = !on;
		}
		if(on) {
			render_printf_framed(&render, 0, 0, 0x82, 3, "%f", fst(BLOCK_SPEED));
			render_printf_framed(&render, 0, 6, 0x82, 3, "%d", JAMA_RATE);
		}
	}
	/*}}DEBUG*/
}

/****************************************************************************
 *	
 ****************************************************************************/

void
rensa_add()
{
	int i;
	int combo;

	combo = game.combo;
	if(!combo) {
		return;
	}
	if(combo > 99) {
		combo = 99;
	}

	for(i = 0; i < RENSA_MAX; i++) {
		if(game.rensa[i].combo < combo) {
			memmove(&game.rensa[i + 1],
				&game.rensa[i],
				sizeof(RENSA) * (RENSA_MAX - (i + 1)));
			game.rensa[i].combo = combo;
			game.rensa[i].cnt = 0;
			/* FALLTHRU */
		}
		if(game.rensa[i].combo == combo) {
			if(game.rensa[i].cnt < 99) {
				game.rensa[i].cnt++;
			}
			game.rensa[i].blink = 1;
			return; /* ܂ */
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
start_disp()
{
	static const struct {
		int spr;
		fixed x;
		fixed y;
		fixed dir;
	} tbl[] = {
		{SPR_MOJI_S,fld(12+ 0),fld(58),fld(M_PI*4/4)},
		{SPR_MOJI_T,fld(12+13),fld(58),fld(M_PI*3/4)},
		{SPR_MOJI_A,fld(12+26),fld(58),fld(M_PI*2/4)},
		{SPR_MOJI_R,fld(12+41),fld(58),fld(M_PI*1/4)},
		{SPR_MOJI_T,fld(12+54),fld(58),fld(M_PI*0/4)},
	};
	//
	int i;
	int x;
	int y;
	int spr;
	int dist;

	if(game.moji_cnt >= 30) {
		return;
	}
	dist = game.moji_cnt - NEXT_OFS_MID;
	if(dist < 0) {
		dist = 0;
	}
	dist *= 6;
	if(game.moji_cnt) {
		game.moji_cnt++;
	}

	for(i = 0; i < ARRAY_SIZE(tbl); i++) {
		spr = tbl[i].spr;
		x = fist(fadd(tbl[i].x, fimul(fcos(tbl[i].dir), dist)));
		y = fist(fadd(tbl[i].y, fimul(fsin(tbl[i].dir), dist)));
		sprite_draw(x, y, spr, DRW_NOMAL);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
gameover_disp()
{
	static const struct {
		int spr;
		int x;
		int y;
		int dir;
	} tbl[] = {
		{SPR_MOJI_G, 0,58,-1},
		{SPR_MOJI_A,11,58,-1},
		{SPR_MOJI_M,23,58,-1},
		{SPR_MOJI_E,35,58,-1},
		{SPR_MOJI_O,44,58, 1},
		{SPR_MOJI_V,56,58, 1},
		{SPR_MOJI_E,68,58, 1},
		{SPR_MOJI_R,77,58, 1},
	};
	//
	int i;
	int x;
	int y;
	int spr;
	int dist;

	dist = game.moji_cnt;
	dist *= 6;
	if(game.moji_cnt) {
		game.moji_cnt--;
	}

	for(i = 0; i < ARRAY_SIZE(tbl); i++) {
		spr = tbl[i].spr;
		x = tbl[i].x + tbl[i].dir * dist;
		y = tbl[i].y;
		sprite_draw(x, y, spr, DRW_NOMAL);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
gameover_init()
{
	int active = 0;
	int cnt = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			cell->stat = CELL_STAT_DARK;
			cell->cnt = cnt;
			active = 1;
		}
		if(active) {
			cnt -= 3; /*  */
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

int
gameover_action()
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			switch(cell->stat) {
			case CELL_STAT_DARK:
				cell->cnt++;
				if(cell->cnt >= BALLxD_CNT) {
					cell->stat = CELL_STAT_OVER;
					cell->cnt = -RND32_RANGE(seed, 10, 30); /*  */
				}
				active = 1;
				break;
			case CELL_STAT_OVER:
				cell->cnt++;
				active = 1;
				break;
			}
		}
	}

	return active;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
mask_disp(int cnt)
{
	int i;
	int j;
	int x;
	int y;
	int spr;

	x = 0;
	for(i = 0; i < 2; i++) {
		for(j = 0; j < 4; j++) {
			spr = SPR_MASK_0 + j;
			y = (j & 1) ? cnt : -cnt;
			sprite_draw(x, y, spr, DRW_NOMAL);
			x += 11;
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
add_score(int add)
{
	game.score += add;
	if(game.score > 99999) {
		game.score = 99999;
	}
}

